unit unMeinDaemon; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, DaemonApp, unMeinServiceThread;

type

  { TMeinDaemon }

  TMeinDaemon = class(TDaemon)
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleStart(Sender: TCustomDaemon; var OK: Boolean);
    procedure DataModuleStop(Sender: TCustomDaemon; var OK: Boolean);
  private
    fLogFileName: String;
    fThread: TMeinServiceThread;
    procedure ThreadStopped(Sender: TObject);
  public
    { public declarations }
  end; 

var
  MeinDaemon: TMeinDaemon;

implementation

procedure RegisterDaemon; 
begin
  RegisterDaemonClass(TMeinDaemon)
end;

{ TMeinDaemon }

procedure TMeinDaemon.DataModuleCreate(Sender: TObject);
begin
  fLogFileName:=ExtractFilePath(Application.ExeName)+'\'+
                ExtractFileNameOnly(Application.ExeName)+'.Log';
end;

procedure TMeinDaemon.DataModuleStart(Sender: TCustomDaemon; var OK: Boolean);
begin
  OK:=(fThread=Nil) and (fLogFileName<>'');
  if OK then begin
    fThread:=TMeinServiceThread.Create(fLogFileName,@ThreadStopped);
  end;
end;

procedure TMeinDaemon.DataModuleStop(Sender: TCustomDaemon; var OK: Boolean);
Var
  i: Integer;
begin
  fThread.Terminate;
  i:=0;
  while (FThread<>Nil) and (i<100) do begin
    inc(i);
    Sleep(100);
    ReportStatus;
  end;
  OK:=True;
end;

procedure TMeinDaemon.ThreadStopped(Sender: TObject);
begin
  //fThread.Destroy;
  fThread:=Nil;
end;

{$R *.lfm}


initialization
  RegisterDaemon; 
end.

