unit unMeinServiceThread;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil;

type

  { TMeinServiceThread }

  TMeinServiceThread = class(TThread)
  private
    fLogFileName: String;
    fSleepP: PEventState;
    procedure AddToLog(Msg: ansistring);
  public
    constructor Create(aLogFileName: String;ATerminate: TNotifyEvent);
    destructor Destroy; override;
    procedure Execute; override;
  end;

implementation

{ TMeinServiceThread }

procedure TMeinServiceThread.AddToLog(Msg: ansistring);
var
  st: TFileStream;
  L: longint;
  s: ansistring;
begin
  if not FileExistsUTF8(fLogFileName) then
  begin
    st := TFileStream.Create(fLogFileName, fmCreate);
    FreeAndNil(st);
  end;
  st := TFileStream.Create(fLogFileName, fmOpenWrite or fmShareDenyWrite);
  st.Position := st.Size;
  s := Utf8ToAnsi(FormatDateTime('dd.mm.yyyy hh:nn:ss', Now) + ' : ' + Msg + #13#10);
  L := Length(S);
  st.WriteBuffer(Pointer(S)^, L);
  FreeAndNil(st);
end;


constructor TMeinServiceThread.Create(aLogFileName: String;ATerminate: TNotifyEvent);
begin
  fSleepP := BasicEventCreate(nil, False, False, 'WakeUp1');
  fLogFileName:=aLogFileName;
  OnTerminate := ATerminate;
  FreeOnTerminate := False;
  inherited Create(False);
end;

destructor TMeinServiceThread.Destroy;
begin
  BasicEventDestroy(fSleepP);
  inherited Destroy;
end;

procedure TMeinServiceThread.Execute;
begin
  AddToLog('Start');

  repeat
    AddToLog('Juhu');
    BasicEventWaitFor(1000, FSleepP);
  until Terminated;

  AddToLog('Ende');
end;

end.

